   window.detailTemplate = null;
   window.listTemplate = null;

   window.listData = {};
   window.lastSameY = false;
   
   window.defaultData =  {};
   window.bridge = null;
   //var used for browser testing
   window.loadingProfile = false;

    function gup( name )
    {
        name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
        var regexS = "[\\?&]"+name+"=([^&#]*)";
        var regex = new RegExp( regexS );
        var results = regex.exec( window.location.href );
        if( results == null )
        return "";
        else
        return results[1];
    }

   function formatTransDate(x) {
       if (x['trans_date']) {
           x['display_date'] = new Date(x['trans_date']).toDateString().substring(3);
       }
   }
   
   function formatThumbnail(x) {
       if (!x['thumbnail']) {
           x['thumbnail'] = window.defaultData.api_host + (x['store_logo_url'] || window.defaultData.default_store_image);
       }
   }
   
   function normalizedData(data) {
        if (data["results"]) {
           _.each(data["results"], function(x) {
               formatTransDate(x);
               formatThumbnail(x);
           }, {});
           window.listData = data;
        } else {
            formatTransDate(data);
        }
   }
   
   function updateUserProfile(profileIcon) {
        if (profileIcon != null) {
            if (console != null) {
                console.log(profileIcon);
            }
            window.defaultData.default_profile_img = profileIcon;
            $(".profilepic").attr("src", profileIcon);
        }
   }

  function handleControllerMessage(msg, p) {
       switch (msg) {
           case "brandName":
                window.defaultData.brand_name = p;
                break;
           case "accessToken":
                window.defaultData.access_token = p;
                break;
           case "apiHost":
                window.defaultData.api_host = p;
                break;
           case "gotUserProfilePic":
                updateUserProfile(p);
                break;
           case "listTemplateReady":
                window.listTemplate = p;
                break;
           case "detailTemplateReady":
                window.detailTemplate = p;
                break;
           case "receiptDataReady":
                var data = JSON.parse(p);
                var t = (data["results"]) ? window.listTemplate : window.detailTemplate;
                normalizedData(data);
                generateTemplate(t, data);
                break;
           case "showListView":
                generateTemplate(window.listTemplate, window.listData);
                break;
           case "apiFailure":
                $("#home").html("apiFailure:<br>" + p);
                break;
           case "profileTemplateReady":
           		window.profileTemplate = p;
           		break;
           case "loadProfile":
               var data = JSON.parse(p);
               generateProfileTemplate(window.profileTemplate, data);
               break;
           case "gotCashBackPct":
               window.defaultData.cashBackPct = p;
               break;

       }
       // notify parent of finishing receiving data from parent.
       notifyParent(msg);
   }

   function onActivityCall(msg) {
       var p = window.Android.getParam(msg);
       handleControllerMessage(msg, p);
   }

   function postMessageToParent(msg) {
       if (window.parent) {
           window.parent.postMessage(msg, '*');
       } else {
           console.log("Can not send message to parent!");
       }
   }
   
   function notifyParent(msg) {
       // check if iOS bridge is defined.
       if (window.bridge) {
            bridge.send(msg, function responseCallback(responseData) {
                console.log("Javascript got its response", responseData);
            });
            return;
       }
       // check if Android bridge is defined:
       if (window.Android && window.Android.callBack) {
           window.Android.callBack(msg);
           return;
       }
       // fallback to iframe (used by harness js)
       postMessageToParent(msg);
       console.log("Android/iOS Callback is not found!", msg);
   }

   //Used in browser testing
   function onApiData(data) {
       postMessageToParent("dataReady");
       if (data["user_icon"]) {
           updateUserProfile(data["user_icon"]);
           return;
       }

       if (data["type"] && data["type"] == "loyaltyprogram") {
           window.cashBackPct = data["results"]["0"].cashback_pct;
           if (window.loadingProfile) {
               generateProfileTemplate(window.profileTemplate, data["results"]["0"]);
               window.loadingProfile = false;
           }
           return;
       }

       var t = (data["results"]) ? window.listTemplate : window.detailTemplate;
       normalizedData(data);
       generateTemplate(t, data);
   }

   function getJsonData(url) {
       // Only used for browser testing, android webview disallow
       // ajax call in local html 5.
        $.ajax({
          type: 'GET',
          url: url,
          dataType: 'json',
          beforeSend: function(xhr){
              xhr.setRequestHeader('Authorization', "Bearer " + window.defaultData.access_token)
          },
          success: onApiData,
          error: function(xhr, type){
              console.log("error getting cross domain data!");
            // TODO add error handling!
          }
        });
               
   }

   function handleMessage(e) {
       if (e.data.ad) {
         notifyParent("ad:" + e.data.ad);
       }
       
       if (e.data.currentAccessCode) {
          window.defaultData.access_token = e.data.currentAccessCode;
          notifyParent("access code:" + e.data.currentAccessCode);
       }

       if (e.data.isProximiantTemplate) {
          window.listTemplate = e.data.listTemplate;
          window.detailTemplate = e.data.detailTemplate;
          window.profileTemplate = e.data.profileTemplate;
          postMessageToParent("templateReady");
       }
       if (e.data.isData) {
           window.defaultData.api_host = e.data.apiHost;
           window.baseUrl = window.defaultData.api_host + e.data.url;
           getJsonData(window.baseUrl);
           postMessageToParent("gettingData");
       }
   }
   
   function stopPropagationOnChild(e) {
       //event.stopPropagation();
   }
   
   function generateTemplate(jadeTemplate, data) {
       if (!jadeTemplate || !data) { return }
       data.data_structured = data.data_structured || {};
       if (typeof(data.data_structured) == "string") {
           data.data_structured = JSON.parse(data.data_structured);
       }
       if (!data.data_structured.items) {
          data.data_structured.items = [];
       }
       numItems = data.data_structured.items.length;
       for (var i=0; i < numItems; i++) { 
           var item = data.data_structured.items[i];
           
           var ask_host = window.defaultData.api_host.replace("pub-api.", "ask.");
           //var ask_host = "http://ask.localhost:8000";
           
           item.prox_ask_url = ask_host + (data.prox_ask_url || '').replace("$productId", item.pid).replace("$accessCode", window.defaultData.access_token);
           if (!item.thumbnail && !item.image) {
               // TODO, add more intelligent break on text
               var t = (item.title || 'My Product').split(/\W/).slice(0, 3).join("|");
               item.thumbnail = "http://chart.apis.google.com/chart?chst=d_text_outline&chld=3E3E3E|16|h|EFEFEF|_|" + t;
           }
       }

       var localData = {};
       $.extend(localData, window.defaultData);
       $.extend(localData, data);

       try {
         var f = jade.compile(jadeTemplate);
         var v = f(localData);
         updatePage(v);
       } catch (err) {
         notifyParent("genTemplateError:" + err.name);
       }
       if (numItems == 0) {
    		$(".receipt_text").show();
       }
       $(".receipt_row").on("click", onReceiptClick);
       $(".like_button").on("click", onLikeClick);
       $(".item_img").on("click", onProdClick);
       $(".title").on("click", onProdClick);
       $(".camera_icon").on("click", onCameraClick);
       $(".recent_purchases").on("click", onRefreshList);
       $("#searchbox").change(onSearch);
       $("#searchbox").focus();
       $(".receipts_list").on("touchmove", onListMove);
       $(".changeview").on("click", onChangeView);
       $(".profilepic").on("click",onClickProfilePic);
       $(".close_btn").on("click", onCloseIframe);
       updateUserProfile(window.defaultData.default_profile_img);
       window.scrollTo(0,0);
   }

   function generateProfileTemplate(jadeTemplate, data) {
       var localData = {};
       $.extend(localData, window.defaultData);
       $.extend(localData, data);
       try {
           var f = jade.compile(window.profileTemplate);
           var v = f(localData);
           updateUserProfile(window.defaultData.default_profile_img);
           updatePage(v);
           $(".profileimage").attr("src", window.defaultData.default_profile_img);
       } catch (err) {
           notifyParent("genTemplateError:" + err.name);
       }
   }

   function onClickProfilePic(e) {
       notifyParent("profile_pic");
       window.loadingProfile = true;
       e.stopPropagation();
   }

   function onChangeView(e) {
       //notifyParent("change_view");
       
       //$(".tiles_view").show();
       //$.get(window.defaultData.tiles_view_url_base, function(data) { $('.tiles_view').html(data); });
       
       $(".tiles_view").toggle();
       $(".receipts_list").toggle();
   }

   function onListMove(e) {
       var t = e.changedTouches[0];
       if (t.pageY == t.screenY && window.lastSameY) {
           // scroll to the very bottom
           notifyParent("list_at_top");
       }
       window.lastSameY = (t.pageY == t.screenY);

   }

   function onSearch(e) {
       notifyParent("search:" + btoa($("#searchbox").val()));
   }

   function onRefreshList(e) {
       notifyParent("refreshList");
   }

   function onCameraClick(e) {
       //console.log($(this).attr("data-rid"));
        e.stopPropagation();
       notifyParent("camera");
   }
   
   function onReceiptClick(e) {
       //console.log($(this).attr("data-rid"));
       notifyParent("receipt-rid:" + $(this).attr("data-rid"));
   }

   function onLikeClick(e) {
       //console.log($(this).attr("data-rid"));
       var v =  $(this).attr("data-link");

       if (v.indexOf("proxAsk") == 0) {
           var item_row = $(this.parentNode.parentNode.parentNode);
           $(item_row).addClass("topMostElement");
           var url = atob(v.split(":")[1]);
           $('.ask').attr('src', url);
           $(".ask_wrapper").addClass("silde_to_top");
           $(".receipt_items").addClass("fixed_position_items");
           $(".receipt_header").css("visibility", "hidden");
             setTimeout(function() {
               var h =  0;
               $('body').height(Math.max(h, $("#home").height()));
             }, 50);
       } else {
           notifyParent("like:" + $(this).attr("data-link"));
       }
   }

   function onProdClick(e) {
       //console.log($(this).attr("data-rid"));
       notifyParent("product:" + $(this).attr("data-link"));
   }
   
   function updatePage(value) {
     $("#home").html(value);
     setTimeout(function() {
       var h =  0;
       $('body').height(Math.max(h, $("#home").height()));
     }, 50);

   }

   function reloadAdsIframe() {
      $(".ad_iframe").each(function() { this.src = this.src; this.contentWindow.location.reload(); });
   }

   function onCloseIframe(e) {
       console.log("close iframe");
       $(".receipt_header").css("visibility", "visible");
       $(".topMostElement").removeClass("topMostElement");
       $(".ask_wrapper").removeClass("silde_to_top");
       $(".ask_wrapper").css("top", "-100%");
       $(".receipt_items").removeClass("fixed_position_items");
   }

   function formatNowWithFallback(fallBackDate) {
         var r;
         try {
            // initialize month names
            var m_names = new Array("January", "February", "March", 
                "April", "May", "June", "July", "August", "September", 
                "October", "November", "December");
            
            // initialize weeday names
            var weekday_names = new Array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday")
            
            // get times
            var d = new Date();
            var curr_day = weekday_names[d.getDay()];
            var curr_date = d.getDate();
            var curr_month = d.getMonth();
            var curr_year = d.getFullYear();
            
            // build the string
            r = curr_day + " - " + m_names[curr_month] + " " + curr_date + " - " + curr_year;
         } catch(e) {
            r = fallBackDate;
         }
         return r; 
    }
    
    function initPage() {
        $("#home").html('');
        $('body').height($("#home").height());

        window.onresize = function(event) {
            setTimeout(function() {
                var h =  0;
                $('body').height(Math.max(h, $("#home").height()));
            }, 50);
        };
        window.addEventListener('message', handleMessage, false);
        if (window.Android) { window.setInterval("reloadAdsIframe();", 15000); }
        $(document).ready(function() {
           notifyParent("loaded");
        });
    }

    document.addEventListener('WebViewJavascriptBridgeReady', function onBridgeReady(event) {
        window.bridge = event.bridge;
        window.bridge.init(function(message, responseCallback) {

            handleControllerMessage(message.type, atob(message.value));
            if (responseCallback) {
                responseCallback(message.type);
            }
        });
        window.bridge.send("loaded");

    }, false);
     