package com.proximiant.html5_ref_app;


import org.json.JSONObject;

import proximiant.sdk.qrcode.QRCodeScanner;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.util.Log;
import android.widget.FrameLayout;

public class MyQrCodeActivity extends QRCodeScanner {

	private static final String TAG = "Proximiant QR Activity";

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.camera);
		setCameraPreview(((FrameLayout) findViewById(R.id.preview)));
	}

	@Override
	public void onQRCodeResult(Boolean success, String code) {
		Log.d(TAG, "QR Result is " + code);
		JSONObject json;
		String rid;
		try {
			json = new JSONObject(code);
			rid = json.getString("rid");
		} catch (Exception e) {
			Log.d(TAG, "Can not parse json " + code);
			return;
		}
		if  (rid == null || rid.equals("")) {
			Log.d(TAG, "empty rid");
			return;
		}

		final Intent receiptIntent = new Intent(this, ReceiptDetailActivity.class);
		receiptIntent.putExtra("rid", rid);
		startActivity(receiptIntent);
		finish();
	}

	@Override
	public void onCameraData(int type, Bitmap bmp){
		Log.d(TAG, "camera type is: " + type);
	}
}
