package com.proximiant.html5_ref_app;

import java.io.IOException;
import java.io.InputStream;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Observable;
import java.util.Observer;

import org.json.JSONObject;

import proximiant.sdk.ProximiantNFCReader;
import proximiant.sdk.ProximiantNfcMessage;
import proximiant.sdk.api.ProximiantApiResult;
import proximiant.sdk.api.ProximiantClientApi;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.media.Ringtone;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Bundle;
import android.os.Vibrator;
import android.util.Base64;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.Window;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebSettings.LayoutAlgorithm;
import android.webkit.WebSettings.ZoomDensity;
import android.webkit.WebView;

@SuppressLint("SetJavaScriptEnabled")
public class ReceiptDetailActivity extends Activity implements Observer {

	private final String TAG = "Proximiant Receipt Detail View";

	private final String RID_KEY = "receipt-rid:";
	private final String PRODUCT_KEY = "product:";
	private final String AD_KEY = "ad:";
	private final String LIKE_KEY = "like:";
	private final String PROX_ASK_KEY = "like:proxAsk:";
	private final String SEARCH_KEY = "search:";
	private final String LIST_AT_TOP = "list_at_top";
	private final String MAIN_PAGE = "file:///android_asset/www/main.html";
	private final String SPLASH_PAGE = "file:///android_asset/www/splash.html";
	private final String RESULTS_ARRAY = "results";

	private final String BRAND_NAME = "Sample App";

	private WebView _myWebView;
	private String _listTemplate = "";
	private String _detailTemplate = "";
	private String _profileTemplate = "";
	private String _jsonData = "";
	private String _loyaltyJsonData = "";
	private String _cashBackPct = "0";
	private Boolean _apiReady = false;
	private Boolean _isDetailView = false;
	private Boolean _isProfileView = false;
	private String _lastListResult;
	private WebAppInterface _myJsBridge = null;
	private final ProximiantClientApi client = new ProximiantClientApi(ProximiantClientApi.PROD);
	
	// DO NOT USE this. This represents an end user for your application that you can use for testing.
	// You need to add a Login User Interface to your application to get a token for users
	// and you should keep the token you get back for a user from the API private

	private final String accessToken = "rg12ez4M57gWGaRufnF6fjxBKTRYNF";

	private String _rid;
	private HashMap<String, String> socialLinks;
	private ProximiantNFCReader _myNfcReader;
	private String _userProfileIcon;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		MyApp.MyGcmService.setProximiantClient(this, client);
		_userProfileIcon = "http://d36ikbmia8fau3.cloudfront.net/img/prox_user.png";
		_lastListResult = "";
		socialLinks = new HashMap<String, String>();

		socialLinks.put("tw", "http://twitter.com/share?url={url}&text={text}&via=Receipt&related=proximiant");
		socialLinks.put("pin", "http://pinterest.com/pin/create/button/?url={url}&media={img}&description={text}");
		socialLinks.put("fb", "http://www.facebook.com/share.php?u={url}");
		socialLinks.put("proxAsk", "{url}");

		_rid = "";
		_detailTemplate = readAssetsText("www/template/receipt_detail.jade");
		_listTemplate = readAssetsText("www/template/receipt_list.jade");
		_profileTemplate = readAssetsText("www/template/profile.jade");

		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_receipt_detail);
		_myWebView = (WebView) findViewById(R.id.webview);

		_myWebView.setWebChromeClient(new WebChromeClient() {
			@Override
			public void onConsoleMessage(String message, int lineNumber, String sourceID) {
				Log.d(TAG, message + " -- From line "
						+ lineNumber + " of "
						+ sourceID);
			}
		});
		_myWebView.setScrollbarFadingEnabled(true);
		_myWebView.setVerticalScrollBarEnabled(false);
		_myWebView.requestFocus(View.FOCUS_DOWN);
		final WebSettings webSettings = _myWebView.getSettings();
		webSettings.setJavaScriptEnabled(true);
		runOnUiThread(new Runnable() {

			@Override
			public void run() {
				// TODO Auto-generated method stub
				webSettings.setDefaultZoom(ZoomDensity.FAR);
			}
		});
		webSettings.setUserAgentString("webkit--proximiant");
		webSettings.setLayoutAlgorithm(LayoutAlgorithm.NORMAL);
		if (android.os.Build.VERSION.SDK_INT  >= android.os.Build.VERSION_CODES.JELLY_BEAN_MR1) {
			webSettings.setAllowUniversalAccessFromFileURLs(true);
			webSettings.setAllowFileAccessFromFileURLs(true);
			webSettings.setAllowContentAccess(true);
			webSettings.setAppCacheEnabled(true);
		}
		_myWebView.clearCache(true);
		_myWebView.clearHistory();
		_myJsBridge = new WebAppInterface(this);
		_myJsBridge.addObserver(this);
		client.addObserver(this);
		_myWebView.addJavascriptInterface(_myJsBridge, "Android");

		client.setAccessCode(accessToken);
		client.getUserProfile();
        client.getLoyaltyPrograms();
		client.setCacheExpire(this, 30);
		Bundle b = getIntent().getExtras();
		String rid = (b!=null) ? b.getString("rid") : "";
		Boolean startByMain = (b!=null) ? b.getBoolean("byMain", false) : false;
		if (rid == null || rid.equals("")) {
			if (startByMain) { _apiReady = false; }
			_myWebView.loadUrl(startByMain ? SPLASH_PAGE : MAIN_PAGE);
			refreshList();
		} else {
			Log.d(TAG, "start with rid: " + rid);
			_myWebView.loadUrl(MAIN_PAGE);

			regNewReceipt(rid);
		}
		_myNfcReader = new ProximiantNFCReader(this);
		_myNfcReader.addObserver(this);

	}

	private void clearAllReceiptsCache() {
		if (client != null) {
			// TODO, only load 1 page for ref app, for real app need to clear cache for all pages.
			// record number of pages somewhere.
			client.clearReceiptsCache(1);
		}
	}

	private void refreshList() {
		// TODO, only assume one page here, need to refresh based on current page?
		client.getReceipts(1);
	}

	private String readAssetsText(String fileName) {
		try {
			InputStream is = getAssets().open(fileName);
			int size = is.available();
			byte[] buffer = new byte[size];
			is.read(buffer);
			is.close();
			return new String(buffer);

		} catch(IOException e) {
			Log.d(TAG, "Can not open template assets!");
			return "";
		}
	}

	private void handleData(final Object data) {
		String msg = data.toString();
		//Log.d(TAG, "handleData: " + msg);
		final Intent cameraIntent = new Intent(this, MyQrCodeActivity.class);

		if (data.getClass() == ProximiantNfcMessage.class) {
			// got new receipt, clear all the cache so we can reload.
			clearAllReceiptsCache();
			try {
				JSONObject json = new JSONObject(data.toString());
				String rid = json.getString("rid");
				Log.d("Proximiant", "rid is: " + rid);
				regNewReceipt(rid);

			} catch (Exception e){
				Log.d("Proximiant", "can not parse json string!");
			}

		} else if (msg.equals("start")) {
			_myWebView.loadUrl(MAIN_PAGE);
			_myWebView.clearHistory();
		} else if (msg.equals("profile_pic")) {
			_apiReady = false;
			_isProfileView = true;
			client.getLoyaltyPrograms();
			invokeJavascript("loadProfile", _loyaltyJsonData);
		} else if (msg.equals("loaded")) {
			_myWebView.clearHistory();
			invokeJavascript("brandName", BRAND_NAME);
		} else if (msg.equals("brandName")) {
			invokeJavascript("accessToken", accessToken);
		} else  if (msg.equals("accessToken")) {
			invokeJavascript("apiHost", client.getApiHost());
		} else  if (msg.equals("apiHost")) {
			invokeJavascript("profileTemplateReady", _profileTemplate);
        } else  if (msg.equals("profileTemplateReady")) {
			invokeJavascript("listTemplateReady", _listTemplate);
		} else  if (msg.equals("listTemplateReady")) {
			invokeJavascript("detailTemplateReady", _detailTemplate);
		} else  if (msg.equals("detailTemplateReady")) {
			invokeJavascript("gotCashBackPct", _cashBackPct);
			invokeJavascript("gotUserProfilePic", _userProfileIcon);
		} else  if (msg.equals("gotUserProfilePic")) {
			_apiReady = true;
			if (_jsonData != null && !_jsonData.isEmpty()) {
				invokeJavascript("receiptDataReady",  _jsonData);
			}
		} else  if (msg.equals("receiptDataReady")) {
		} else  if (msg.equals("camera")) {
			startActivity(cameraIntent);
		} else if (msg.equals("refreshList")) {
			_lastListResult = "";
			//refreshList();
		} else if (data.getClass() == ProximiantApiResult.class) {

			ProximiantApiResult r = (ProximiantApiResult) data;
			// ProximiantApiResult is coming from async http call
			// if need to invoke multiple api call at the same time
			// need to update here to make it thread safe.
			// currently, making assumption that only one api call at a time.
			if (r.getType().equals(ProximiantClientApi.RECEIPT_LIST) ||
					r.getType().equals(ProximiantClientApi.RECEIPT_DETAIL)) {
				_jsonData = r.getJsonString();

				if (_apiReady && !_lastListResult.equals(_jsonData)) {
					Log.d(TAG, "update list result");
					invokeJavascript("receiptDataReady",  _jsonData);
				}
				_lastListResult = _jsonData;
			} else if (r.getType().equals(ProximiantClientApi.API_FAILURE)) {
				Log.d(TAG, "fail to invoke api" + r.getJsonString());
				if (_apiReady) {
					invokeJavascript("apiFailure", r.getJsonString());
				}
				_lastListResult = "";
			} else if (r.getType().equals(ProximiantClientApi.REG_RECEIPT)) {
				client.getReceiptByRid(_rid);
				client.getLoyaltyPrograms();
				_lastListResult = "";
				_isDetailView = true;
			} else if (r.getType().equals(ProximiantClientApi.USER_PROFILE)) {
				String userIcon = null;
				try {
					JSONObject json = r.getJsonObject();
					userIcon = json.getString("user_icon");
				} catch (Exception e) {
					Log.d(TAG, "can not get json object" + r.getJsonString());
				}
				Log.d(TAG, "user profile icon from server is:" + userIcon);
				if (userIcon != null && !userIcon.isEmpty()) {
					_userProfileIcon = userIcon;
					if (_apiReady) { invokeJavascript("gotUserProfilePic", _userProfileIcon); }
				}
			} else if (r.getType().equals(ProximiantClientApi.LOYALTY)) {
				try {
					JSONObject json = r.getJsonObject();
					org.json.JSONArray array =  json.getJSONArray(RESULTS_ARRAY);
					json = array.getJSONObject(0);
					_loyaltyJsonData = json.toString();
					_cashBackPct = json.getString("cashback_pct");
					invokeJavascript("gotCashBackPct", _cashBackPct);
				} catch (Exception e) {
					Log.d(TAG, "can not get json object" + r.getJsonString());
				}
			}

		} else if (msg.indexOf(RID_KEY) == 0) {
			// get rid from msg and invoke the api.
			_isDetailView = true;
			_lastListResult = "";
			String rid = msg.substring(RID_KEY.length());
			client.getReceiptByRid(rid);
		} else if (msg.indexOf(SEARCH_KEY) == 0) {
			String[] separated = msg.split(":");
			_lastListResult = "";
			if (separated.length !=2 || "".equals(separated[1])) {
				refreshList();
			} else {
				String query = decode64(separated[1]);
				Log.d(TAG, "search result " + query);
				client.searchReceipts(query, 1);
			}
		} else if (msg.indexOf(PRODUCT_KEY) == 0 || msg.indexOf(AD_KEY) == 0 ) {
			String[] separated = msg.split(":");
			OpenUrlInBrowser(decode64(separated[1]));
		} else if (msg.indexOf(PROX_ASK_KEY) == 0) {
			String[] separated = msg.split(":");
			OpenUrlInBrowser(decode64(separated[2]));
		} else if (msg.indexOf(LIKE_KEY) == 0) {
			String[] separated = msg.split(":");
			String base = socialLinks.get(separated[1]);
			if (base == null) {
				Log.d(TAG, "invalid social link:" + msg);
			} else {
				String url = urlEncode(decode64(separated[2]));
				String img = urlEncode(decode64(separated[3]));
				String prod = urlEncode(decode64(separated[4]));
				String text = urlEncode("I just bought @" + BRAND_NAME + " " + prod);
				OpenUrlInBrowser(base.replace("{img}", img).replace("{url}", url).replace("{title}", BRAND_NAME).replace("{text}", text));
			}
		} else if (msg.indexOf(LIST_AT_TOP) == 0) {
			clearAllReceiptsCache();
			refreshList();
		} else {
			Log.d(TAG, "No matching:" + msg);
		}

	}

	@Override
	public void update(Observable observable, Object data) {
		Log.d("Proximiant", "Got callback from observerable, data=" + data.toString());
		final Object d = data;
		runOnUiThread(new Runnable() {
			@Override
			public void run() {
				handleData(d);
			}
		});

	}

	private String urlEncode(String value) {
		String result = "";
		try {
			result = URLEncoder.encode(value, "UTF-8");
		} catch (Exception e) {
			Log.d(TAG, "url encode error: " + value);
		}
		return result;

	}

	private String decode64(String value) {
		String result = "";
		try {
			byte[] b = Base64.decode(value, Base64.DEFAULT);
			result = new String(b, "UTF-8");
		} catch (Exception e) {
			Log.d(TAG, "can not decode value: " + value);
		}
		return result;
	}

	private void regNewReceipt(String rid) {
		_rid = rid;
		_isDetailView = true;
		client.registerReceipt(rid);
		clearAllReceiptsCache();
		try {
			Uri notification = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
			Ringtone r = RingtoneManager.getRingtone(getApplicationContext(), notification);
			r.play();
			Vibrator v = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
			// Vibrate for 1000 milliseconds
			v.vibrate(1000);
		} catch (Exception e) {}
	}

	private void OpenUrlInBrowser(String url) {
		if (url == null || url.indexOf("http") < 0) {
			return;
		}
		Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(url));
		startActivity(browserIntent);
	}

	private void invokeJavascript(final String apiName, final String data) {
		if (_myWebView == null || _myWebView.getUrl() == null || _myWebView.getUrl().isEmpty()) { return; }
		try {
			runOnUiThread(new Runnable() {
				@Override
				public void run() {
					_myJsBridge.setData(apiName, data);
					_myWebView.loadUrl("javascript:onActivityCall(\"" + apiName +"\");");
				}
			});

		} catch (Exception e) {
			Log.d(TAG, "Error invoking Javascript from webview" + e.getMessage());
			return;
		}
	}

	@Override
	protected void onNewIntent(Intent intent) {
		super.onNewIntent(intent);
		// getIntent() should always return the most recent
		setIntent(intent);
	}

	@Override
	protected void onResume() {
		super.onResume();
		if (_myNfcReader != null) {
			_myNfcReader.enableDetection();
		}
		clearAllReceiptsCache();

		// TEMP
		try {
			invokeJavascript("receiptDataReady",  _jsonData);
		}
		catch (Exception ex) {

		}
	}

	@Override
	protected void onPause() {
		super.onPause();
		if (_myNfcReader != null) {
			_myNfcReader.disableForeground();
		}

	}

	// TODO, uncomment if we want to use system back button to go back page.
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		// Check if the key event was the Back button and if there's history
		Boolean goBack = false;
		if ((keyCode == KeyEvent.KEYCODE_BACK)) {
			if (_isDetailView){
				goBack = true;
				_lastListResult = "";
				refreshList();
			} else if (_isProfileView) {
				goBack = true;
				_myWebView.loadUrl(MAIN_PAGE);
				_isProfileView = false;
			} else if (_myWebView.canGoBack()) {
				goBack = true;
				_myWebView.goBack();
			}

		}
		_isDetailView = false;
		if (goBack) { return true; }
		// If it wasn't the Back key or there's no web page history, bubble up to the default
		// system behavior (probably exit the activity)
		return super.onKeyDown(keyCode, event);
	}

}
