package com.proximiant.html5_ref_app;

import java.util.HashMap;
import java.util.Observable;
import java.util.concurrent.locks.ReentrantReadWriteLock;

import android.content.Context;
import android.util.Log;
import android.webkit.JavascriptInterface;

public class WebAppInterface extends Observable {
	private final String TAG = "Proximiant WebAppInterface";
	Context mContext;
	private String lastMsg = "";
	private final HashMap<String, String> h;
	final private ReentrantReadWriteLock rwl = new ReentrantReadWriteLock();

	/** Instantiate the interface and set the context */
	WebAppInterface(Context c) {
		mContext = c;
		h = new HashMap<String, String>();
	}

	/** Show a toast from the web page */
	@JavascriptInterface
	public void callBack(String msg) {
		if (lastMsg.equals(msg)) {
			Log.d(TAG, "msg is the same");
		}
		setChanged();
		lastMsg = msg;
		notifyObservers(msg);
	}

	@JavascriptInterface
	public String getParam(String msg) {
		rwl.readLock().lock();
		String result = h.get(msg);
		rwl.readLock().unlock();
		return result;
	}

	protected void setData(String msg, String data) {
		rwl.writeLock().lock();
		h.put(msg, data);
		rwl.writeLock().unlock();
	}


}
