//
//  ProxViewController.m
//  FbLoginSample
//
//  Created by rui yang on 9/17/13.
//  Copyright (c) 2013 rui yang. All rights reserved.
//

#import "ProxViewController.h"
#import <FacebookSDK/FacebookSDK.h>
#import "ProximiantClientApi.h"

#define PROX_CLIENT_ID @"fa308aa42b791c22ee2425eeddba172eb27d9902"

@interface ProxViewController () <FBLoginViewDelegate> {
  
}

@property (nonatomic, strong) ProximiantClientApi * client;
@property (copy) void (^myApiCallBack)(NSString*, NSString*);
@property (strong, nonatomic) IBOutlet FBProfilePictureView *profilePic;
@property (strong, nonatomic) IBOutlet UILabel *labelFirstName;
@property (strong, nonatomic) id<FBGraphUser> loggedInUser;

@end

@implementation ProxViewController

@synthesize labelFirstName = _labelFirstName;
@synthesize loggedInUser = _loggedInUser;
@synthesize profilePic = _profilePic;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
  self.client = [[ProximiantClientApi alloc] initWithEnv:DEV];
  ProxViewController* __weak weakSelf = self;

  self.myApiCallBack = ^(NSString* type, NSString* value){
    NSDictionary * json = [NSJSONSerialization JSONObjectWithData:[value dataUsingEncoding:NSUTF8StringEncoding] options:0 error:nil];
    if ([type isEqualToString:PROX_ACCESS_TOKEN]){
      NSString * accessToken = [json objectForKey:@"access_token"];
      NSLog(@"Proximiant Access Token is %@", accessToken);
        // invoke one of the Proximiant api.
      [weakSelf.client getUserProfile:weakSelf.myApiCallBack];
    } else if ([type isEqualToString:USER_PROFILE]){
      NSString * icon = [json objectForKey:@"user_icon"];
      NSLog(@"user icon is %@", icon);
    }
    
  };
    // show facebook login
    // Create Login View so that the app will be granted "status_update" permission.
  FBLoginView *loginview = [[FBLoginView alloc] initWithReadPermissions:@[@"email",]];
  
  loginview.frame = CGRectOffset(loginview.frame, 15, 18);
  
  loginview.delegate = self;
  
  [self.view addSubview:loginview];
  
  [loginview sizeToFit];
  NSLog(@"hello world");
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - FBLoginViewDelegate

- (void)loginViewShowingLoggedInUser:(FBLoginView *)loginView {
  NSLog(@"logined in user");
}

- (void)loginViewFetchedUserInfo:(FBLoginView *)loginView
                            user:(id<FBGraphUser>)user {
    // here we use helper properties of FBGraphUser to dot-through to first_name and
    // id properties of the json response from the server; alternatively we could use
    // NSDictionary methods such as objectForKey to get values from the my json object
  NSLog(@"Hello %@! -- %@", user.first_name, user.id);
    // setting the profileID property of the FBProfilePictureView instance
    // causes the control to fetch and display the profile picture for the user
  
  NSString * fbToken = [FBSession activeSession].accessTokenData.accessToken;
  NSLog(@"facebook token is: %@", fbToken);
  [self.client getAccessTokenByFacebookToken:fbToken clientId:PROX_CLIENT_ID done:self.myApiCallBack];
  
}

- (void)loginViewShowingLoggedOutUser:(FBLoginView *)loginView {
    // test to see if we can use the share dialog built into the Facebook application
  FBShareDialogParams *p = [[FBShareDialogParams alloc] init];
  p.link = [NSURL URLWithString:@"http://developers.facebook.com/ios"];
#ifdef DEBUG
  [FBSettings enableBetaFeatures:FBBetaFeaturesShareDialog];
#endif
  
}

- (void)loginView:(FBLoginView *)loginView handleError:(NSError *)error {
    // see https://developers.facebook.com/docs/reference/api/errors/ for general guidance on error handling for Facebook API
    // our policy here is to let the login view handle errors, but to log the results
  NSLog(@"FBLoginView encountered an error=%@", error);
}

#pragma mark -

@end
