//
//  ProxViewController.m
//  proxRefApp
//
//  Created by rui yang on 8/28/13.
//  Copyright (c) 2013 rui yang. All rights reserved.
//

#import "ProxViewController.h"
#import "ProximiantClientApi.h"
#import "WebViewJavascriptBridge.h"
#import "AFHTTPClient.h"
#import "ProxCameraViewController.h"


#define PROX_CLIENT_ID @"fa308aa42b791c22ee2425eeddba172eb27d9902"

  // http://d21yh141wo3k7p.cloudfront.net/questions/www/main.html
  // http://localhost:3001/www/main.html
#define PROX_ROOT_URL  @"http://d21yh141wo3k7p.cloudfront.net/questions/www/main.html"


#define BRAND_NAME @"Prox demo"

#define ACCESS_TOKEN  @"Eguon3CUOwLAdDznD7sJANsRLFXj6x"

@interface ProxViewController ()  {
  BOOL _webviewLoaded;
  NSDictionary * _socialLink;
}
@property (nonatomic, strong) ProximiantClientApi * client;

@property (nonatomic, strong) WebViewJavascriptBridge * bridge;
@property (nonatomic, strong) NSString * accessToken;

@property (nonatomic, strong) NSString * listTemplate;
@property (nonatomic, strong) NSString * detailTemplate;
@property (nonatomic, strong) NSString * listData;
@property (nonatomic, strong) NSString * detailData;
@property (nonatomic, strong) NSString * apiHost;

@property (nonatomic, strong) AFHTTPClient * httpClient;



@property (copy) APICALLBACK myApiCallBack;


@end

@implementation ProxViewController



- (void)viewDidLoad
{

  [super viewDidLoad];
  _socialLink = [NSDictionary dictionaryWithObjectsAndKeys:
                 @"http://twitter.com/share?url={url}&text={text}&via=Receipt&related=proximiant", @"tw",
                 @"http://www.facebook.com/share.php?u={url}", @"fb",
                 @"http://pinterest.com/pin/create/button/?url={url}&media={img}&description={text}", @"pin",
                 nil];
  self.viewWeb.delegate = self;

  [self.viewWeb.scrollView setBounces:NO];
  ProxViewController* __weak weakSelf = self;
  
  _webviewLoaded = NO;
    // Do any additional setup after loading the view, typically from a nib.
  self.client = [[ProximiantClientApi alloc] initWithEnv:PROD];
  
  self.apiHost = [[self.client getApiHost] stringByReplacingOccurrencesOfString:@"/v1/" withString:@""];
  
  self.httpClient = [AFHTTPClient clientWithBaseURL:[NSURL URLWithString:@"http://d21yh141wo3k7p.cloudfront.net"]];

  [self.httpClient getPath:@"questions/www/template/receipt_list.jade" parameters:nil success:^(AFHTTPRequestOperation *operation, id r){
        weakSelf.listTemplate = [[NSString alloc] initWithData:r encoding:NSUTF8StringEncoding];
        [weakSelf checkAllDataReady];
      } failure:nil];
  [self.httpClient getPath:@"questions/www/template/receipt_detail.jade" parameters:nil success:^(AFHTTPRequestOperation *operation, id r){
        weakSelf.detailTemplate = [[NSString alloc] initWithData:r encoding:NSUTF8StringEncoding];
        [weakSelf checkAllDataReady];
  } failure:nil];
  // Create Login View so that the app will be granted "status_update" permission.


  
  self.bridge = [WebViewJavascriptBridge bridgeForWebView:self.viewWeb handler:^(id data, WVJBResponseCallback responseCallback) {
    NSLog(@"Received message from javascript: %@", data);
    if ([data isEqualToString:@"loaded"]) {
      [weakSelf webviewLoaded];
    } else if ([data isEqualToString:@"allReady"]) {
      [weakSelf checkAllDataReady];
    } else if ([data rangeOfString:@"receipt-rid:"].location != NSNotFound) {
      NSString * rid = [data stringByReplacingOccurrencesOfString:@"receipt-rid:" withString:@""];
      [weakSelf.client getReceiptByRid:rid done:weakSelf.myApiCallBack];
    } else if ([data isEqualToString:@"refreshList"]) {
      [weakSelf.client getReceipts:1 done:weakSelf.myApiCallBack];
    } else if ([data rangeOfString:@"product:"].location != NSNotFound ||
               [data rangeOfString:@"ad:"].location != NSNotFound) {
      NSArray* a = [data componentsSeparatedByString:@":"];
      NSURL * url = [NSURL URLWithString:[weakSelf.client decodeB64String:a[1]]];
      [[UIApplication sharedApplication] openURL:url];
    } else if ([data rangeOfString:@"like:"].location != NSNotFound) {
      NSArray* a = [data componentsSeparatedByString:@":"];
      NSString * base = [_socialLink objectForKey:a[1]];
      NSString * link = [weakSelf escapeSocialParam:a[2]];
      NSString * img = [weakSelf escapeSocialParam:a[3]];
      NSString * prod = [weakSelf escapeSocialParam:a[4]];
      NSString * brand = [weakSelf escapeSocialParam:BRAND_NAME];
      NSString* text = [[NSArray arrayWithObjects:@"I%20just%20bought%20@", brand, prod, nil]
                         componentsJoinedByString:@"%20"];
      NSString * rawUrl = [[[[base stringByReplacingOccurrencesOfString:@"{img}" withString:img]
                           stringByReplacingOccurrencesOfString:@"{url}" withString:link ]
                           stringByReplacingOccurrencesOfString:@"{title}" withString:brand]
                           stringByReplacingOccurrencesOfString:@"{text}" withString:text];
      NSURL * url = [NSURL URLWithString:rawUrl];
      NSLog(@"open new url %@", rawUrl);
      [[UIApplication sharedApplication] openURL:url];
    } else if ([data rangeOfString:@"search:"].location != NSNotFound) {
      NSArray* a = [data componentsSeparatedByString:@":"];
      NSString* v = [weakSelf.client decodeB64String:a[1]];
      [weakSelf.client searchReceipts:v page:1 done:weakSelf.myApiCallBack];
    }  else if ([data isEqualToString:@"camera"]) {
      ProxCameraViewController * camera = [[ProxCameraViewController alloc] init];
      camera.client = weakSelf.client;
      camera.myApiCallBack = weakSelf.myApiCallBack;
      [weakSelf presentViewController:camera animated:YES completion:nil];
    }
      //responseCallback(@"Right back atcha");
  }];
  [self.viewWeb loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:PROX_ROOT_URL]]];
  
  self.myApiCallBack = ^(NSString* type, NSString* value, NSDictionary * json){
    if ([type isEqualToString:RECEIPT_LIST]){
      weakSelf.listData = value;
      [weakSelf checkAllDataReady];
    } else if ([type isEqualToString:RECEIPT_DETAIL]){
      weakSelf.detailData = value;
      [weakSelf sendMessage:@"receiptDataReady" value:weakSelf.detailData];
    } else if ([type isEqualToString:USER_PROFILE]){
      [weakSelf sendMessage:@"gotUserProfilePic" value:[json objectForKey:@"user_icon"]];
    }  else if ([type isEqualToString:CAMERA_RECEIPT] || [type isEqualToString:REG_RECEIPT]){
      NSString * rid = [json objectForKey:@"rid"];
      [weakSelf.client getReceiptByRid:rid done:weakSelf.myApiCallBack];
    }
    
  };

  [self.client setAccessCode:ACCESS_TOKEN];
  [self.client getUserProfile:self.myApiCallBack];
    // need to remember refresh token here to grab next access token.
  [self.client getReceipts:1 done:self.myApiCallBack];
}

- (NSString*) escapeSocialParam:(NSString*) value {
  NSString * raw = [self.client decodeB64String:value];
  if (raw == nil) { raw = value; }
  return (NSString *)CFBridgingRelease(CFURLCreateStringByAddingPercentEscapes(
                                                                        NULL,
                                                                        (__bridge CFStringRef) raw,
                                                                        NULL,
                                                                        CFSTR("!*'();:@&=+$,/?%#[]"),
                                                                        kCFStringEncodingUTF8));
}

- (void) sendMessage:(NSString*) type value: (NSString*) v {
  NSString * b64 = [self.client b64EncodeString:v];

  [self.bridge send:[NSDictionary dictionaryWithObjectsAndKeys:type, @"type", b64, @"value", nil]];
}

- (void) checkAllDataReady {
  if (!_webviewLoaded || self.listTemplate == nil || self.detailTemplate == nil || self.listData == nil) {
    NSLog(@"Not ready yet");
    return;
  }
  [self sendMessage:@"listTemplateReady" value:self.listTemplate];
  [self sendMessage:@"detailTemplateReady" value:self.detailTemplate];
  [self sendMessage:@"receiptDataReady" value:self.listData];
}

- (void) webviewLoaded {
  [self sendMessage:@"brandName" value:BRAND_NAME];
  [self sendMessage:@"accessToken" value:self.accessToken];
  [self sendMessage:@"apiHost" value:self.apiHost];
   _webviewLoaded = YES;
  [self sendMessage:@"allReady" value:@""];
}

- (void)webViewDidFinishLoad:(UIWebView *)webView {

}

-(void)webViewDidStartLoad:(UIWebView *)webView {
  NSLog(@"start");
}

-(void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error {
  NSLog(@"Error for WEBVIEW: %@", [error description]);
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}



@end
